#line 1 "E:/Dropbox/ProjektyMikroC/ButtonSwitch8channel/ButtonSwitch8channel.c"
#line 1 "c:/mikroc pro for pic/include/built_in.h"
#line 7 "E:/Dropbox/ProjektyMikroC/ButtonSwitch8channel/ButtonSwitch8channel.c"
const char DV_BUTTON = 1;
const char CHANNEL_COUNT = 8;

unsigned char address_hi;
unsigned char address_lo;
unsigned char address_subsystem;

const unsigned char crc_tab[]={
0, 49, 98, 83, 196, 245, 166, 151, 185, 136, 219, 234, 125, 76, 31, 46, 67, 114, 33, 16,
135, 182, 229, 212, 250, 203, 152, 169, 62, 15, 92, 109, 134, 183, 228, 213, 66, 115, 32, 17,
63, 14, 93, 108, 251, 202, 153, 168, 197, 244, 167, 150, 1, 48, 99, 82, 124, 77, 30, 47,
184, 137, 218, 235, 61, 12, 95, 110, 249, 200, 155, 170, 132, 181, 230, 215, 64, 113, 34, 19,
126, 79, 28, 45, 186, 139, 216, 233, 199, 246, 165, 148, 3, 50, 97, 80, 187, 138, 217, 232,
127, 78, 29, 44, 2, 51, 96, 81, 198, 247, 164, 149, 248, 201, 154, 171, 60, 13, 94, 111,
65, 112, 35, 18, 133, 180, 231, 214, 122, 75, 24, 41, 190, 143, 220, 237, 195, 242, 161, 144,
7, 54, 101, 84, 57, 8, 91, 106, 253, 204, 159, 174, 128, 177, 226, 211, 68, 117, 38, 23,
252, 205, 158, 175, 56, 9, 90, 107, 69, 116, 39, 22, 129, 176, 227, 210, 191, 142, 221, 236,
123, 74, 25, 40, 6, 55, 100, 85, 194, 243, 160, 145, 71, 118, 37, 20, 131, 178, 225, 208,
254, 207, 156, 173, 58, 11, 88, 105, 4, 53, 102, 87, 192, 241, 162, 147, 189, 140, 223, 238,
121, 72, 27, 42, 193, 240, 163, 146, 5, 52, 103, 86, 120, 73, 26, 43, 188, 141, 222, 239,
130, 179, 224, 209, 70, 119, 36, 21, 59, 10, 89, 104, 255, 206, 157, 172};

const char TYPE_DISCOVERY = 0;
const char TYPE_DISCOVERY_RESPONSE = 1;
const char TYPE_DISCOVERY_ADDRESS = 2;
const char TYPE_DISCOVERY_CHECK = 4;
const char TYPE_DISCOVERY_CHECK_OK = 5;
const char TYPE_REQUEST = 10;
const char TYPE_GET = 11;
const char TYPE_SET = 12;

unsigned int random;
unsigned char random_lo;
unsigned char random_hi;

unsigned int count;

const int time_baudrate = 100;
int delay_time;

bit has_address;
bit timeout;
bit start_char;

unsigned char state;

unsigned char received[80];
unsigned char received_index = 0;
unsigned char send[40];


unsigned char received_char;

unsigned char calculate_checksum(unsigned char * t, short start_index, short stop_index ){
 short index;
 unsigned char crc_value=0;
 for(index=start_index; index<=stop_index; index++)
 {
 crc_value= crc_tab[ (crc_value ^ t[index]) ];
 }
 return crc_value;
}

unsigned char create_checksum(unsigned char * t, short length){
 short index;
 unsigned char crc_value=0;
 crc_value= crc_tab[ (crc_value ^ length) ];
 for(index=0; index< length; index++)
 {
 crc_value= crc_tab[ (crc_value ^ t[index]) ];
 }
 return crc_value;

}

void us_delay(unsigned int time) {
 int index = 0;
 for (index = 0; index < time; index ++) {
 Delay_us(time_baudrate);
 }
}


void send_packet (unsigned char * tx, short length) {
 short index;
 Delay_us(250);
  RB6_bit  = 1;
 Delay_us(50);
 UART1_Write('#');
 UART1_Write(length);
 for (index = 0; index < length; index++) {
 UART1_Write(tx[index]);
 }
 UART1_Write(create_checksum(tx, length));
 UART1_Write('$');
 delay_time = length+4;
 us_delay(delay_time);
  RB6_bit  = 0;
}

void send_packet_random (unsigned char * tx, short length, unsigned int ran) {
 int index = 0;
 Delay_ms(10);
 for (index = 0; index < ran*5; index ++) {
 Delay_us(1);
 }
  RB6_bit  = 1;
 Delay_us(100);
 UART1_Write('#');
 UART1_Write(length);
 for (index = 0; index < length; index++) {
 UART1_Write(tx[index]);
 }
 UART1_Write(create_checksum(tx, length));
 UART1_Write('$');
 delay_time = length+4;
 us_delay(delay_time);
  RB6_bit  = 0;
}

void init() {

 has_address = 0;

 address_hi = EEPROM_Read(0x00);
 address_lo = EEPROM_Read(0x01);
 address_subsystem = EEPROM_Read(0x02);
 if (address_hi != 0xFF && address_lo != 0xFF) {
 has_address = 1;
 }
}

void discovery_response() {
 unsigned char index = 0;
 int rand = 0;
 for (index = 0; index < 10; index++) {
 rand = ADC_Read(0);
 if (rand > 0) {
 random = rand;
 break;
 }
 }
 if (rand == 0) {
 random = rand() / 32;
 }

 rand = 0;
 for (index = 0; index < 10; index++) {
 rand = ADC_Read(1);
 if (rand > 0) {
 random = rand;
 break;
 }
 }
 if (rand == 0) {
 random = (rand() / 32) * random;
 } else {
 random = rand * random;
 }

 random_lo = random & 0xff;
 random_hi = random >> 8;
 send[0] = TYPE_DISCOVERY_RESPONSE;
 send[1] = CHANNEL_COUNT;
 send[2] = DV_BUTTON;
 send[3] = random_hi;
 send[4] = random_lo;
 send_packet_random(send, 5, random);
}

void discovery_address() {

 address_hi = received[5];
 address_lo = received[6];
 address_subsystem = received[7];
}

void discovery_check() {
 send[0] = TYPE_DISCOVERY_CHECK;
 send[1] = random_hi;
 send[2] = random_lo;
 send[3] = address_hi;
 send[4] = address_lo;
 send[5] = address_subsystem;
 send_packet (send, 6);
}

void discovery_check_ok() {
 EEPROM_Write(0x00, address_hi);
 EEPROM_Write(0x01, address_lo);
 EEPROM_Write(0x02, address_subsystem);
 has_address = 1;
}

void get() {
 send[0] = TYPE_GET;
 send[1] = address_hi;
 send[2] = address_lo;
 send[3] = address_subsystem;
 send[4] = PORTC;
 send_packet (send, 5);
}

void check_packet_no_address() {
 if (
 (received[0] == '#') &&
 (received[received_index - 1] == calculate_checksum(received, 1, received_index - 2)) &&
 (received[received_index] == '$')
 ) {

 TMR1ON_bit = 0;
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 start_char = 0;
 if (received[2] == TYPE_DISCOVERY) {
 discovery_response();
 }
 if (received[2] == TYPE_DISCOVERY_ADDRESS && received[3] == random_hi && received[4] == random_lo) {
 discovery_address();
 discovery_check();
 }
 if (received[2] == TYPE_DISCOVERY_CHECK_OK && received[3] == random_hi && received[4] == random_lo) {
 discovery_check_ok();
 }
 timeout = 1;
 }
}

void check_packet_address() {
 if (
 (received[0] == '#') &&
 (received[received_index - 1] == calculate_checksum(received, 1, received_index - 2)) &&
 (received[received_index] == '$')
 ) {

 TMR1ON_bit = 0;
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 start_char = 0;

 if (received[2] == TYPE_REQUEST && received[3] == address_hi && received[4] == address_lo && received[5] == address_subsystem) {
 get();
 }

 timeout = 1;
 }

}

void interrupt() {
 if (T1IF_bit) {
 T1IF_bit = 0;
 timeout = 1;
 TMR1ON_bit = 0;
 TMR1H = 0xD8;
 TMR1L = 0xF0;
  RB4_bit  = 1;
 Delay_ms (20);
  RB4_bit  = 0;
 }
}



void resetNode() {
 EEPROM_Write(0x00, 0xFF);
 EEPROM_Write(0x01, 0xFF);
 EEPROM_Write(0x02, 0xFF);

 for (count = 0; count < 6; count++) {
  RA2_bit  = 1;
  RB4_bit  = 1;
 Delay_ms(50);
  RA2_bit  = 0;
  RB4_bit  = 0;
 Delay_ms(50);
 }

 {asm CLRF PCLATH;
 asm GOTO 0x00;}
}

void main() {



 OSTS_bit = 0;
 TRISC = 255;
 TRISB.F6 = 0;
 TRISB.F4 = 0;
 TRISA = 255;
 TRISA.F2 = 0;
 ANSEL = 3;
 ANSELH = 0;

 UART1_Init(115200);
 Delay_ms(100);

  RB6_bit  = 0;

 timeout = 0;
 start_char = 0;
 init();
 GIE_bit = 1;
 PEIE_bit = 1;

 T1CKPS1_bit = 1;
 T1CKPS0_bit = 1;
 T1OSCEN_bit = 1;
 TMR1CS_bit = 0;
 TMR1ON_bit = 1;
 T1IE_bit = 1;
 TMR1H = 0xD8;
 TMR1L = 0xF0;

  RB4_bit  = 0;
  RA2_bit  = 1;

 count = 0;
 PORTC = 255;

 while (has_address == 0) {
 count ++;
 if (count == 50000) {
 count = 0;
  RA2_bit  = ~( RA2_bit );
 }

 if (RA3_bit == 1) {
 resetNode();
 }

 if (timeout == 1) {
 received_index = 0;
 timeout = 0;
 start_char = 0;
 TMR1ON_bit = 0;
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 }

 if (UART1_Data_Ready() == 1) {
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 TMR1ON_bit = 1;


 received_char = UART1_Read();
 if ((received_char == '#') && start_char == 0) {
 start_char = 1;
 }
 if (start_char == 1 && received_index < 40) {
 received[received_index] = received_char;
 if (received_index > 3 && received_char == '$') {
 check_packet_no_address();
 }
 received_index++;
 }
 }
 }

  RA2_bit  = 1;
 state = PORTC;
 start_char = 0;
 received_index = 0;

 while(1) {
 if (RA3_bit == 1) {
 resetNode();
 }

 if (timeout == 1) {
 received_index = 0;
 timeout = 0;
 start_char = 0;
 TMR1ON_bit = 0;
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 }

 if (UART1_Data_Ready() == 1) {
 TMR1H = 0xD8;
 TMR1L = 0xF0;
 TMR1ON_bit = 1;

 received_char = UART1_Read();
 if ((received_char == '#') && start_char == 0) {
 start_char = 1;
 }
 if (start_char == 1 && received_index < 40) {
 received[received_index] = received_char;
 if (received_index > 3 && received_char == '$') {
 check_packet_address();
 }
 received_index++;
 }
 }
 }
}
