#include "Delegator.h"

#include "Connector.h"
#include "Planner.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

/* Public methods: */

Delegator::Delegator() {
}

Delegator::~Delegator() {
}

void Delegator::setPlanner(Planner* pln) {
	this->pPlanner = pln;
}

void Delegator::setConnector(Connector* con) {
	this->pConnector = con;
}

void Delegator::setAddress(unsigned char address) {
	this->address = address;
	pPlanner->setAddress(address);
}

void Delegator::addNode(Node &node) {
	pPlanner->addNode(node);
}

void Delegator::addType(DeviceType &type) {
	pPlanner->addType(type);
}

void Delegator::removeNode(Node & node) {
	pPlanner->removeNode(node);
}

void Delegator::setNodeData(Node &node) {
	pPlanner->setNodeData(node);
}

void Delegator::updateNodeData(Node& node) {
	pConnector->updateNodeData(node);
}

void Delegator::startPlanners() {
	pPlanner->start();
}

void Delegator::requestNewAddresses(nodeMap& nodes) {
	pConnector->requestNewAddresses(nodes);
}

void Delegator::discoverNewNodes() {
	pPlanner->discoverNewNodes();
}

void Delegator::addressNewNodes(nodeMap &newNodes) {
	pPlanner->addressNewNodes(newNodes);
}

void Delegator::logError(unsigned char errorNumber) {
	pConnector->logError(errorNumber);
}

void Delegator::logError(unsigned char errorNumber, unsigned short nodeAddress) {
	pConnector->logError(errorNumber, nodeAddress);
}

void Delegator::addNodeToMap(Node &node) {
	pConnector->addNodeToMap(node);
}
