#ifndef DELEGATOR_H_
#define DELEGATOR_H_

#include "DeviceType.h"
#include "Node.h"

#include <unordered_map>

typedef std::unordered_map<unsigned short, Node> nodeMap;

class Planner;
class Connector;

class Delegator {
public:
	Delegator();
	virtual ~Delegator();
	void setPlanner(Planner *pln);
	void setConnector(Connector *con);


	//From Planners to Connector
	void setAddress(unsigned char);
	void updateNodeData(Node &);
	void startPlanners();
	void requestNewAddresses(nodeMap &nodes);

	void logError(unsigned char);
	void logError(unsigned char, unsigned short);
	void addNodeToMap(Node &node);


	//From Conector to Planners
	void setNodeData(Node &);
	void addType(DeviceType &);
	void addNode(Node &);
	void removeNode(Node &);
	void discoverNewNodes();
	void addressNewNodes(nodeMap &newNodes);


private:
	unsigned char address;

protected:
	Connector *pConnector;
	Planner *pPlanner;
};

#endif
