#include "Node.h"

/*Public methods: */

Node::Node() {
	errorTime = 0;
}

Node::~Node() {
	//delete data;
}

unsigned short Node::getAddress() const {
	return address;
}

void Node::setAddress(unsigned short address) {
	this->address = address;
}

unsigned int Node::getChannelCount() const {
	return channelCount;
}

void Node::setChannelCount(int channelCount) {
	this->channelCount = channelCount;
}

unsigned short Node::getRandom() const {
	return random;
}

void Node::setRandom(unsigned short random) {
	this->random = random;
}

DeviceType Node::getType() const {
	return type;
}

void Node::setType(DeviceType type) {
	this->type = type;
}

bool Node::isWired() const {
	return wired;
}

void Node::setWired(bool wired) {
	this->wired = wired;
}

unsigned int** Node::getData() const {
	return data;
}

void Node::setData(unsigned int** data) {
	this->data = data;
}

bool Node::isChange() const {
	return change;
}

void Node::setChange(bool change) {
	this->change = change;
}

unsigned long Node::getErrorTime() {
	return errorTime;
}

void Node::setErrorTime(unsigned long errorTime) {
	this->errorTime = errorTime;
}

void Node::makeData() {
	this->data = new unsigned int*[channelCount];
	int dataCount = type.getDataCount();
	for (int i = 0; i < channelCount; i++) {
		data[i] = new unsigned int[dataCount];
	}

	bitLength = channelCount * type.getDataCount() * type.getDataRange();
	byteLength = bitLength / 8;

	if (bitLength % 8 > 0) {
		byteLength++;
	}
}

unsigned char Node::getDataLength() {
	return byteLength;
}
