#include "TCPSocket.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <cstring>
#include <iostream>
#include <string>

#define BUFSIZE 1000

using namespace std;

char* hostname;
int port;

hostent *host;
sockaddr_in serverSock;
int mySocket;

int size;
string text;

int TCPSocket::openSocket() {
	// Zjistíme info o vzdáleném počítači
	if ((host = gethostbyname(hostname)) == NULL) {
		cerr << "Špatná adresa" << endl;
		return -1;
	}
	// Vytvoříme soket
	if ((mySocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1) {
		cerr << "Nelze vytvořit soket" << endl;
		return -1;
	}
	// Zaplníme strukturu sockaddr_in
	// 1) Rodina protokolů
	serverSock.sin_family = AF_INET;
	// 2) Číslo portu, ke kterému se připojíme
	serverSock.sin_port = htons(port);
	// 3) Nastavení IP adresy, ke které se připojíme
	memcpy(&(serverSock.sin_addr), host->h_addr, host->h_length);
	// Připojení soketu
	if (connect(mySocket, (sockaddr *) &serverSock, sizeof(serverSock)) == -1) {
		cerr << "Nelze navázat spojení" << endl;
		return -1;
	}
	return 1;
}

TCPSocket::TCPSocket() {
}

TCPSocket::TCPSocket(char *host, int prt) {
	hostname = host;
	port = prt;
}

TCPSocket::~TCPSocket() {
}

int TCPSocket::init() {
	return openSocket();
}

int TCPSocket::init(char *hn, int pr) {
	hostname = hn;
	port = pr;

	return openSocket();
}

string TCPSocket::receiveData() {
	rsize = recv(mySocket, rbuf, sizeof(rbuf), 0);
	rbuf[rsize] = '\0';
	string str(rbuf);

	return str;
}

void TCPSocket::sendData(string txt) {
	if ((size = send(mySocket, txt.c_str(), txt.size() + 1, 0)) == -1) {
		cerr << "Problém s odesláním dat" << endl;
	}
}

