#ifndef UART_H
#define UART_H

#include <termios.h>

#include <string>

class UART {
public:

	/* Bezne nazvy UART portu v linuxu:
	"/dev/ttyS0","/dev/ttyS1","/dev/ttyS2","/dev/ttyS3","/dev/ttyS4","/dev/ttyS5",
	"/dev/ttyS6","/dev/ttyS7","/dev/ttyS8","/dev/ttyS9","/dev/ttyS10","/dev/ttyS11",
	"/dev/ttyS12","/dev/ttyS13","/dev/ttyS14","/dev/ttyS15","/dev/ttyUSB0",
	"/dev/ttyUSB1","/dev/ttyUSB2","/dev/ttyUSB3","/dev/ttyUSB4","/dev/ttyUSB5",
	"/dev/ttyAMA0","/dev/ttyAMA1","/dev/ttyACM0","/dev/ttyACM1",
	"/dev/rfcomm0","/dev/rfcomm1","/dev/ircomm0","/dev/ircomm1"*/
	UART(std::string, int);
	UART();
	virtual ~UART();


	int openUART();
	int openUART(std::string, int);

	void flush();

	int pollComport(unsigned char *, int);
	int sendByte(unsigned char);
	int sendBuf(unsigned char *, int);
	void closeComport();
	void cputs(const char *);

	//metody specialne pro RS232, nektere UART hlavne integrovane v ruznych CPU, toto rizeni neobsahuje
	int isDCDEnabled();
	int isCTSEnabled();
	int isDSREnabled();
	void enableDTR();
	void disableDTR();
	void enableRTS();
	void disableRTS();

private:
	int baudrate;
	int port;
	const char* portname;
	int error;

	struct termios portSettings;

protected:


};

#endif
