#include "Connector.h"

#include "Delegator.h"
#include "Planner.h"
#include "TCPSocket.h"

#include "simpleini/SimpleIni.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <thread>
#include <unistd.h>
#include <chrono>

using namespace std;


string confFile = "hausy.conf";


int main() {
	CSimpleIniA conf;

	//nacteni konfigurace ze souboru hausy.conf
	//pokud neni pritomna, pouzivaji se defaultni hodnoty localhost a port 10007

	conf.SetUnicode();
	conf.LoadFile(confFile.c_str());
	const char * ip = conf.GetValue("settings",
	    "ip", NULL);
	const char * port = conf.GetValue("settings",
	    "port", NULL);
	const char * uart = conf.GetValue("settings",
	    "uart", NULL);
	const char * gpio = conf.GetValue("settings",
	    "gpio", NULL);


	//vyvoreni instanci trid konektoru, delegatoru a planovace
	//tridy jsou instancovany pouze jednou a maji referenci
	//na ostatni tridy
	Connector con;
	Planner pln(uart, gpio);
	Delegator dlg;


	//nastaveni vzajemnych referenci. Konektor vidi pouze delegator.
	//Planovac vidi pouze delegator, a delegator predava data mezi nimy.
	con.setDelegator(&dlg);
	pln.setDelegator(&dlg);
	dlg.setConnector(&con);
	dlg.setPlanner(&pln);

	TCPSocket socket((char *) ip, atoi(port));
	int sNum = socket.init();
	if (sNum == 1) {
		con.setTCPSocket(socket);
		con.start();
	}


	return 0;
}
