#ifndef NODE_H_
#define NODE_H_

#include "DeviceType.h"
#include <chrono>

class Node {
public:
	Node();
	virtual ~Node();

	unsigned short getAddress() const;
	unsigned int getChannelCount() const;
	unsigned short getRandom() const;
	DeviceType getType() const;
	bool isWired() const;
	bool isChange() const;
	unsigned int** getData() const;
	unsigned char getDataLength();
	unsigned long getErrorTime();

	void setAddress(unsigned short address);
	void setChannelCount(int channelCount);
	void setRandom(unsigned short random);
	void setType(DeviceType type);
	void setWired(bool wired);
	void setData(unsigned int**);
	void setChange(bool change);
	void setErrorTime(unsigned long errorTime);

	void makeData();

private:
	DeviceType type;
	int channelCount;
	unsigned short random;
	unsigned short address;
	unsigned char byteLength;
	unsigned char bitLength;
	bool wired;
	bool change;

	unsigned long errorTime;

	/*Pointer to pointer (2D array) which stores data iself.
	 * It is in format data[channel][count]*/
	unsigned int **data;

};

#endif
